/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//NPM Imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const {exceptionHandler, errorHandler} = require('../../../utils/loggerUtils');
const {userModel} = require('../../../schemas/user/userSchema');
const channelModel = require('../../../schemas/channel/channelSchema');
const permissionModel = require('../../../schemas/permissionSchema')

//api account functions
module.exports.get = async function(req, res){
    try{
        //Get validation result
        const validResult = validationResult(req);
        
        //If we data is valid
        if(validResult.isEmpty()){
            //Set channel object from sanatized/validated data, and get user document from session data
            const {chanName} = matchedData(req);
            const chanDB = await channelModel.findOne({name: chanName});

            res.status(200);
            return res.send(await chanDB.getChanBans());
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}

module.exports.post = async function(req, res){
    try{
        //Get validation result
        const validResult = validationResult(req);
        
        //If we data is valid
        if(validResult.isEmpty()){
            //Set channel object from sanatized/validated data, and get user document from session data
            const {chanName, user, expirationDays, banAlts} = matchedData(req);
            const initiatorDB = await userModel.findOne({user: req.session.user.user});
            const targetDB = await userModel.findOne({user});
            const chanDB = await channelModel.findOne({name: chanName});

            //get initiator and target override abilities
            const override = await permissionModel.overrideCheckByUserDoc(initiatorDB, 'banUser');
            const targetOverride = await permissionModel.overrideCheckByUserDoc(targetDB, 'banUser');

            //Get channel ranks
            const initiatorChanRank = await chanDB.getChannelRankByUserDoc(initiatorDB);
            const targetChanRank = await chanDB.getChannelRankByUserDoc(targetDB);

            //If we're targeting a null user
            if(targetDB == null){
                //If the user is null, scream and shout
                return errorHandler(res, `User not found.`, 'Bad Query', 400);
            //if self ban
            }else if(targetDB.user == req.session.user.user){
                //If some smart-ass is trying to self-ban
                return errorHandler(res, `Keep it up, maybe I will ban you!`, 'Unauthorized', 401);
            //otherwise
            }else{
                //If someone involved has the ability to override
                if(override || targetOverride){
                    //If the site rank is equal
                    if(permissionModel.rankToNum(initiatorDB.rank) == permissionModel.rankToNum(targetDB.rank)){
                        //compare chan rank
                        if(permissionModel.rankToNum(initiatorChanRank) <= permissionModel.rankToNum(targetChanRank)){
                            //error out over bad chan rank
                            return errorHandler(res, 'You cannot ban peer/outranking users', 'Unauthorized', 401);
                        }
                    //otherwise
                    }else{
                        //compare site rank
                        if(permissionModel.rankToNum(initiatorDB.rank) <= permissionModel.rankToNum(targetDB.rank)){
                            //shame the person running it
                            return errorHandler(res, 'You cannot ban this user due to site-wide permissions override policies.', 'Unauthorized', 401);
                        }
                    }
                }else{
                    if(permissionModel.rankToNum(targetChanRank) >= permissionModel.rankToNum(initiatorChanRank)){
                        //If the user is trying to ban a peer/outranking user
                        return errorHandler(res, 'You cannot ban peer/outranking users', 'Unauthorized', 401);
                    }
                }
            }

            await chanDB.banByUserDoc(targetDB, expirationDays, banAlts);

            res.status(200);
            return res.send(await chanDB.getChanBans());
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}

module.exports.delete = async function(req, res){
    try{
        //Get validation result
        const validResult = validationResult(req);
        
        //If we data is valid
        if(validResult.isEmpty()){
            //Set channel object from sanatized/validated data, and get user document from session data
            const {chanName, user} = matchedData(req);
            const userDB = await userModel.findOne({user});
            const chanDB = await channelModel.findOne({name: chanName});

            await chanDB.unbanByUserDoc(userDB);

            res.status(200);
            return res.send(await chanDB.getChanBans());
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}